package com.mortals.xhx.busiz.message.impl;

import com.mortals.framework.util.security.sm.SM4Utils;
import com.mortals.xhx.busiz.message.MessageService;
import com.mortals.xhx.busiz.req.MessageReq;
import com.mortals.xhx.common.utils.RSAUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * DeviceService
 * 设备 service实现
 *
 * @author zxfei
 * @date 2022-03-09
 */
@Service("messageService")
@Slf4j
public class MessageServiceImpl implements MessageService {

    @Override
    public MessageReq decryptMessage(MessageReq req) {
        if ("RSA".equalsIgnoreCase(req.getAlgorithm())) {
            String decryptContent = RSAUtils.decode(req.getContent(), req.getPassword());

            MessageReq messageReq = new MessageReq();
            messageReq.setKey(req.getKey());
            messageReq.setDecryptContent(decryptContent);
            return messageReq;
        }else if ("SM4".equalsIgnoreCase(req.getAlgorithm())) {
            SM4Utils sm4Utils = new SM4Utils();
            sm4Utils.setSecretKey(req.getPassword());
            String decryptContent =sm4Utils.decryptData_ECB(req.getDecryptContent());
            MessageReq messageReq = new MessageReq();
            messageReq.setKey(req.getKey());
            messageReq.setDecryptContent(decryptContent);
            return messageReq;
        }
        return req;
    }

    @Override
    public MessageReq encryptMessage(MessageReq req) {
        if ("RSA".equalsIgnoreCase(req.getAlgorithm())) {
            String decryptContent = RSAUtils.decode(req.getContent(), req.getPassword());
            MessageReq messageReq = new MessageReq();
            messageReq.setKey(req.getKey());
            messageReq.setDecryptContent(decryptContent);
            return messageReq;
        }else if ("SM4".equalsIgnoreCase(req.getAlgorithm())) {
            SM4Utils sm4Utils = new SM4Utils();
            sm4Utils.setSecretKey(req.getPassword());
            String decryptContent= sm4Utils.encryptData_ECB(req.getContent());
             MessageReq messageReq = new MessageReq();
            messageReq.setKey(req.getKey());
            messageReq.setDecryptContent(decryptContent);
            return messageReq;
        }
        return req;
    }
}